divert(-1)
#
# Modified by John Capo <jc@irbs.com> to refuse bogus domains and
# mail from dotted quad addresses but allow mail from daemons, <>.
#
# Copyright (c) 1996 Claus Assmann <ca@informatik.uni-kiel.de>
#
# In short: you can do whatever you want with this, but don't blame me!
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
divert(0)
VERSIONID(`@(#)check_mail.m4')
PUSHDIVERT(6)
#
# file containing full e-mail addresses of well-known spammers:
# spammer@address.domain SPAMMER
# or junk domain:
# junk.domain JUNK
#
# makemap hash /etc/junk < junklist_text_file
#
Kjunk ifelse(_ARG_, `', `hash /etc/junk', `_ARG_')
POPDIVERT

divert(2)
LOCAL_RULESETS

Sjunk

R$*<@$+>$*		$: $1<@$(junk $2$)>$3		# lookup domain in database
R$*<@JUNK>$*		$@ $1<@JUNK>$2			# exists? return
R$*<@$+>$*		$: $1<@$(junk $1@$2 $:$2$)>$3	# lookup address in database
R$*<@SPAMMER>$*		$@ $1<@SPAMMER>$2		# exists? return
R$*<@$-.$-.$+>$*	$: $2<@> $>junk $1<@$3.$4>$5	# mv one subdomain in front, try again

# Not really needed since the caller only looks for
# $* JUNK> $* and $* SPAMMER> $*
R$*<@>$*<@$+>$*		$2<@$1.$3>$4			# undo damage

Scheck_mail

R<>			$@ ok			Mailer deamons  Bummer!!
R<$*@$=w>		$@ ok			shortcut
R$*			$: $>3 $1		canonify
R$-			$@ ok			local host

# no host without a . in the FQHN ?
R$*<@$->$*		$#error $@ 5.1.8 $: 518 invalid host name $2
R$*<@>$*		$#error $@ 5.1.8 $: 518 invalid host name $2

# Refuse bogus domains and spammer@[1.2.3.4]
R$*<@[$-.$-.$-.$-]>	$#error $@ 5.7.1 $: "571 No mail from dotted quad addresses"
R$*<@$*$~P>$*		$#error $@ 4.1.8 $: 418 unresolvable host name $2$3

# now remove the dot
R$*<@$*.>$*		$: $1<@$2>$3

# and check the database
R$*<@$*>$*		$: $>junk $1<@$2>$3
R$*<@$*JUNK>$*		$#error $@ 5.7.1 $: "571 We do not except junk mail."
R$*<@$*SPAMMER>$*	$#error $@ 5.7.1 $: "571 We do not except junk mail."

divert(0)
